function  C2p29_PSET2_2
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #2, Problem #2
% 03/08/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

close all, clear all,%clc

warning off
f =@(x) sin(x)*exp(x)+cos(2*x)^2*exp(-x);
Df=@(x) (sin(x)+cos(x))*exp(x)+(-cos(2*x)^2-4*cos(2*x)*sin(2*x))*exp(-x);

%ezplot(f,[-4:.01:4]);

Methods={'Newton', 'Secant','Modified False-Position', 'False-Position','Bi-Section' };
LS={'-','--',':','-.','none'};
LM={'+','o','*','.','s'};


IG(1,1:2)={3.1,[3.1 3.2]}; %Initial Guess
IG(2,1:2)={-.7,[-.7 -.5]};
IG(3,1:2)={-1.1,[-1.1 -.9]};
IG(4,1:2)={-2.35,[-2.35 -2.2]};
IG(5,1:2)={-2.5,[-2.5 -2.35]};

IG(6,1:2)={7*pi-.1,[7*pi-.1 7*pi+.1]};
IG(7,1:2)={8*pi-.1,[8*pi-.1 8*pi+.1]};
xd=-pi*(6+3/4);
IG(8,1:2)={xd-.2,[xd-.2 xd]};
IG(9,1:2)={xd+.2,[xd xd+.2]};
%IG(1,1:2)={-21.3,[-21.3 -21.1]};
%IG{8,1}=xd+.2;

for k=1:9
    SOL=cell(5,3);
    if k==6 || k==7
        x_r=(k+1)*pi;
        fprintf('\n k=%d , x_r~=k*pi=%+18.16f, f(k*pi)=%+8.6e\n',k+1,x_r,f(x_r));
    elseif k==8 || k==9
        x_r=xd;
        fprintf('\n x_r~=(6+3/4)*pi=%+18.16f, f(x_r)=%+8.6e\n',x_r,f(x_r));
    end
    for i=1:1   % Solving
        if i==1
            IG_h=IG{k,1};
        else
            IG_h=IG{k,2};
        end
        [SOL{i,1},SOL{i,2},SOL{i,3}]=solver(f,IG_h,'method',Methods{i},'f_derivative',Df,...
            'max_iteration',40,'abs_tolerance',1e-20,'rel_tolerance',1e-16,'plot','off','display','off');
    end
    return
    warning off
    n_max=1;    % Find Plot Limits
    low_e=inf;up_e=-inf;
    x_min=inf;x_max=-inf;
    for i=1:5
        x_itr=SOL{i,2};
        x_best=SOL{i,1};
        e_rel=abs(x_itr(:,end)-x_best)./abs(x_best);
        low_e=min(low_e,floor(log10(min(e_rel))));
        up_e =max(up_e  ,ceil(log10(max(e_rel))));
        x_min=min(x_min,min(x_itr(:,end)));
        x_max=max(x_max,max(x_itr(:,end)));
        n_max=max(n_max, size(x_itr,1));
    end

    ax1_Limit=[1 n_max x_min x_max];%[1 n_max min(IG_h) max(IG_h)]
    ax2_Limit=[1 n_max -17 -1];%ax2_Limit=[1 n_max 10^low_e 10^up_e]

    for i=1:5 % Plotting
        x_itr=SOL{i,2};
        x_best=SOL{i,1};
        e_rel=abs(x_itr(:,end)-x_best)./abs(x_best);
        N=[1:size(x_itr,1)];
        if i==1
            figure
            plot(N,x_itr(:,end),'Marker',LM{i},'LineStyle',LS{i});
            ax1=gca;hold on
            ax2 = axes('Position',get(ax1,'Position'),...
                'XAxisLocation','bottom',...
                'YAxisLocation','right',...
                'Color','none',...
                'XColor','k','YColor','r');
            hold on
            plot(ax2,N(1:end-1),log10(e_rel(1:end-1)),'color','r','Marker',LM{i},'LineStyle',LS{i});
        else
            plot(ax1,N,x_itr(:,end),'Marker',LM{i},'LineStyle',LS{i});
            plot(ax2,N,log10(e_rel),'color','r','Marker',LM{i},'LineStyle',LS{i});
        end
    end
    axis(ax2,ax2_Limit);
    axis(ax1,ax1_Limit);
    set(ax1,'xgrid','on')
    set(ax1,'ygrid','on')
    %set(ax2,'ygrid','on')
    set(ax1,'ylimmode','auto')
    set(ax2, 'xTickLabel','')
    legend(ax1,'Newton', 'Secant','Modified False-Position', 'False-Position','Bi-Section')
    hold on, box on, grid on
    FN_Size_A=16;
    FN_Size_T=14;

    set(ax1,'fontsize',14),set(ax2,'fontsize',14)

    xlabel(ax1,'n (Iteration Number)','Interpreter','latex','fontsize',FN_Size_A,'VerticalAlignment','top',...
        'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
    ylabel(ax1,'x','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
    ylabel(ax2,'$log_{10}(\epsilon_a)$ (relative error of x)','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

    title (['$f(x)=e^xsin x +e^{-x}cos ^22x$ root using initial guess of $x_0=' num2str(IG_h(1)) ','  num2str(IG_h(2)) '$'],'Interpreter','latex',...
        'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

    set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
    set(gcf,'Position',[50 50 [24 18]*30],'color','w')
end
fprintf('\n')
