function  C2p29_PSET2_6p1
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #2, Problem #3, Textbook Problem #6.1
% 03/08/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

close all, clear all,%clc

f=@(x) 2*sin(x^.5)-x;
g=@(x) f(x)+x;

eps_rel=inf;
eps_des=1e-5;

x_o=0.5;
k=0;

x_itr(1)=x_o;

while min(eps_rel)>eps_des
    k=k+1;
    x_n=g(x_o);
    x_itr(k+1)=x_n;
    eps_rel(k)=abs(x_n-x_o)/abs(x_o);
    x_o=x_n;
end
x_sol=x_n;

fprintf('\n\n Final Solution: f(x=%+20.16f)=%+8.6e with %s method and %d iterations \n ',x_sol,f(x_sol),'Fixed Point',k)

AX=plotyy([1:k+1],x_itr,[1:k+1],[eps_rel NaN],@plot,@semilogy); %

hold on, box on, grid on
FN_Size_A=16;
FN_Size_T=14;
set(AX(1),'fontsize',14),set(AX(2),'fontsize',14)
xlabel('n (Iteration Number)','Interpreter','latex','fontsize',FN_Size_A,...
    'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel(AX(1),'x','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel(AX(2),'$\epsilon_a$ (relative error of x)','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

title (['Root of  $2sin\sqrt{x}-x$'],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

%legend('\sigma_{rr}','\sigma_{\theta\theta}','\sigma_{Mises}','Location','Southwest')
set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
set(gcf,'Position',[50 50 [20 18]*30],'color','w')