function  C2p29_PSET2_6p11
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #2, Problem #3, Textbook Problem #6.11
% 03/08/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************

close all, clear all,clc


f  =@(x) x^3-2*x^2-4*x+8;
Df =@(x) 3*x^2-4*x-4;
DDf=@(x) 6*x-4;

f_a=f;
f_b=@(x) 2*f(x);

f_c =@(x) f(x)*Df(x);
Df_c=@(x) Df(x)^2-f(x)*DDf(x);

SOL=cell(3,3);
LS={'-','--',':','-.','none'};
LM={'+','o','*','.','s'};

fprintf('\n Case a:')
i=1;
[SOL{i,1},SOL{i,2},SOL{i,3}]=solver(f_a,1.2,'method','newton','f_derivative',Df,...
    'max_iteration',40,'abs_tolerance',1e-20,'rel_tolerance',1e-16,'plot','off','display','off');
fprintf('\n Case b:')
i=2;
[SOL{i,1},SOL{i,2},SOL{i,3}]=solver(f_b,1.2,'method','newton','f_derivative',Df,...
    'max_iteration',40,'abs_tolerance',1e-20,'rel_tolerance',1e-16,'plot','off','display','off');
fprintf('\n Case c:')
i=3;
[SOL{i,1},SOL{i,2},SOL{i,3}]=solver(f_c,1.2,'method','newton','f_derivative',Df_c,...
    'max_iteration',40,'abs_tolerance',1e-20,'rel_tolerance',1e-16,'plot','off','display','off');

warning off
n_max=1;    % Find Plot Limits
low_e=inf;up_e=-inf;
x_min=inf;x_max=-inf;
for i=1:3
    x_itr=SOL{i,2};
    x_best=2;
    e_rel=abs(x_itr(:,end)-x_best)./abs(x_best);
    low_e=min(low_e,floor(log10(min(e_rel))));
    up_e =max(up_e  ,ceil(log10(max(e_rel))));
    x_min=min(x_min,min(x_itr(:,end)));
    x_max=max(x_max,max(x_itr(:,end)));
    n_max=max(n_max, size(x_itr,1));
end

ax1_Limit=[1 n_max x_min x_max];%[1 n_max min(IG_h) max(IG_h)]
ax2_Limit=[1 n_max -17 -1];%ax2_Limit=[1 n_max 10^low_e 10^up_e]

for i=1:3 % Plotting
    x_itr=SOL{i,2};
    x_best=2;
    e_rel=abs(x_itr(:,end)-x_best)./abs(x_best);
    N=[1:size(x_itr,1)];
    if i==1
        figure
        plot(N,x_itr(:,end),'Marker',LM{i},'LineStyle',LS{i});
        ax1=gca;hold on
        ax2 = axes('Position',get(ax1,'Position'),...
            'XAxisLocation','bottom',...
            'YAxisLocation','right',...
            'Color','none',...
            'XColor','k','YColor','r');
        hold on
        plot(ax2,N(1:end-1),log10(e_rel(1:end-1)),'color','r','Marker',LM{i},'LineStyle',LS{i});
    else
        plot(ax1,N,x_itr(:,end),'Marker',LM{i},'LineStyle',LS{i});
        plot(ax2,N,log10(e_rel),'color','r','Marker',LM{i},'LineStyle',LS{i});
    end
end
axis(ax2,ax2_Limit);
axis(ax1,ax1_Limit);
set(ax1,'xgrid','on')
set(ax1,'ygrid','on')
%set(ax2,'ygrid','on')
set(ax1,'ylimmode','auto')
set(ax2, 'xTickLabel','')
legend(ax1,'a) Newton-Raphson', 'b) Newton-Raphson','c) Newton-Raphson')
hold on, box on, grid on
FN_Size_A=16;
FN_Size_T=14;

set(ax1,'fontsize',14),set(ax2,'fontsize',14)

xlabel(ax1,'n (Iteration Number)','Interpreter','latex','fontsize',FN_Size_A,'VerticalAlignment','top',...
    'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel(ax1,'x','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')
ylabel(ax2,'$log_{10}(\epsilon_a)$ (relative error of x)','Interpreter','latex','fontsize',FN_Size_A,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

title (['$f(x)=x^3-2*x^2-4*x+8$ root using initial guess of $x_0=1.2$'],'Interpreter','latex',...
    'fontsize',FN_Size_T,'FontAngle','italic','FontWeight','bold','FontName','Times New Roman')

set(gcf,'PaperType','usLetter','PaperOrientation','portrait','PaperUnits','Centimeters','PaperPosition',[1 1 20 18])
set(gcf,'Position',[50 50 [24 18]*30],'color','w')

fprintf('\n')
