function  [x]=C2p29_PSET2_7(A,b)
%function [x]=gauss(A,b) % A: n*n matrix, b: n*1 vector where Ax=b
%%
% ********************************************************************
% Course Homework
%               2.29: Numerical Fluid Mechanincs, Spring 2007
% Problem Set #2, Problem #1
% 03/08/07
% ********************************************************************
% Reza Karimi:
%                            Graduate Student
%                    Mechanical Engineering Department
%                  Massachusetts Institute of Technology
% Email:  rkarimi@mit.edu
% Office: NE47-319, 500 Technology Square, Cambridge, MA 02139
% Phone: (617) 324-7605
% ********************************************************************


%% Original Version
% Ab=[A b];
% n=length(A);
% for i=1:n-1
%     for j=i+1:n
%         m=-Ab(i,i)/Ab(j,i);
%         for k=1:n+1
%             Ab(j,k)=m*Ab(j,k)+Ab(i,k);
%         end
%     end
% end
% x=zeros(n,1);
% for i=n:-1:1
%     sum=Ab(i,n+1);
%     for j=i+1:n
% 
%         sum=sum-x(j)*Ab(i,j);
%     end
%     x(i)=sum/Ab(i,i);
% end


%% Modified C
% Ab=[A b];
% n=length(A);
% for i=1:n-1
%     for j=i+1:n
%         if Ab(j,i)~=0
%             m=-Ab(j,i)/Ab(i,i);
%             Ab(j,i:end)=Ab(j,i:end)+m*Ab(i,i:end);
%         end
%     end
% end
% x=zeros(n,1);
% for i=n:-1:1
%     sum=Ab(i,n+1)
%     if i<n
%         sum=sum-Ab(i,i+1:n)*x(i+1:end);
%     end
%     x(i)=sum/Ab(i,i)
% end

%% Modified D: Scaled Partial Pivoting
Ab=[A b];
n=length(A);
for i=1:n-1
    Scaled_Coeff=Ab(i:n,i)./max(max(Ab(i:n,i:n),[],2),abs(min(Ab(i:n,i:n),[],2)));
    [pivot,index]=max(Scaled_Coeff);
    if pivot==0
        error('Matrix is singular');
    elseif index~=1
        temp               =Ab(i        ,i:end);
        Ab(i        ,i:end)=Ab(i-1+index,i:end);
        Ab(i-1+index,i:end)=temp;
    end
    for j=i+1:n
        if Ab(j,i)~=0
            m=-Ab(j,i)/Ab(i,i);
            Ab(j,i:end)=Ab(j,i:end)+m*Ab(i,i:end);
        end
    end
end
x=zeros(n,1);
for i=n:-1:1
    sum=Ab(i,n+1);
    if i<n
        sum=sum-Ab(i,i+1:n)*x(i+1:end);
    end
    x(i)=sum/Ab(i,i);
end